//////////////////////////////////////////////////////////////////////////////////
// Lens Flare V1.0.0. a jQuery plugin.
// (c) 2010 by R Cecco. <http://www.professorcloud.com>
// MIT License
//
// Please retain this copyright header in all versions of the software
//////////////////////////////////////////////////////////////////////////////////

(function($) {		
	
	
	function Flare( lightSource, flaresData  )
	{
		this.flares = [];
		this.hidden=false;
		this.lightSource = lightSource;
		this.flaresData = flaresData;		
		lightSource.data('LensFlare',this);						
	
		this.update = function()
		{							
			var	startX = this.lightSource.position().left + this.lightSource.width()/2 ;
			var	startY = this.lightSource.position().top + this.lightSource.height()/2;
			var	par = this.lightSource.parent();
			
			var	v1 = new Vector2d( (par.width()/2) - startX, (par.height()/2) - startY);			
			var	len = v1.normalise() * 2;						
		
			for (var i=0 ;i < this.flares.length; i++)			
			{
				var	v = new Vector2d(v1);
				v.mul( this.flares[i].offset * len );								
				this.flares[i].img.css('left',(v.vx + startX - this.flares[i].halfWidth ) + 'px');
				this.flares[i].img.css('top', (v.vy + startY - this.flares[i].halfHeight) + 'px');						
			}					
		};
		
		
		this.show = function()
		{
			if(!this.hidden) { return; }
			this.hidden = false;
			for (var i=0 ;i < this.flares.length; i++)			
			{
				this.flares[i].img.css('display','block');
			}
		};
		
		this.hide = function()
		{
			if (this.hidden) { return ; }
			this.hidden = true;
			for (var i=0 ;i < this.flares.length; i++)			
			{
				this.flares[i].img.css('display','none');
			}
		};
		
		var	imgLoaded = function(event)
		{
				var	evd = event.data;				
				var	iw = this.width * this.scale;
				var	ih = this.height * this.scale;
				var domImg = evd.lightSource.parent().append("<img style='position:absolute;' src='" + this.src + "'" + "width='"+iw+"'" + "height='"+ih+"'" +  "/>").find(':last');
				if(evd.hidden) { domImg.css('display','none'); }
				evd.flares.push( { img:domImg,  halfWidth: iw/2, halfHeight: ih/2, offset:this.offset } );	
				evd.update();
		};
		
		for (var i = 0; i < flaresData.length; i ++ )
		{
			var	img = new Image();
			
			$(img).bind('load', this, imgLoaded);						
			img.scale = flaresData[i].scale;
			img.offset = flaresData[i].offset;
			img.src = flaresData[i].src;		
		}
		
	}
	
	$.fn.LensFlareUpdate = function()
	{
		this.each( function() {		
				$(this).data('LensFlare').update();			
		});
	};
	
	$.fn.LensFlareShow = function()
	{
		this.each( function() {		
				$(this).data('LensFlare').show();			
		});
	};
	
	$.fn.LensFlareHide = function()
	{
		this.each( function() {		
				$(this).data('LensFlare').hide();			
		});
	};
	
	// The jQuery plugin part. 
	$.fn.LensFlare = function(flaresData, options) {					
		var flares = [];
		this.each( function() {												
			options = $.extend({}, {},options );															
			flares.push( new Flare( $(this), flaresData ) );		
		});				
		return this;
	};

})(jQuery);